<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#if  item.getAllPSDEDataSets()??>
<#assign resultSet=item.getAllPSDEDataSets()>
</#if>
<#if  item.getAllPSDEDataQueries()??>
<#assign dataQueries=item.getAllPSDEDataQueries()>
</#if>
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper
	namespace="${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.mapper.${item.codeName}Mapper">
	<!--该方法用于重写mybatis中selectById方法，以实现查询逻辑属性-->
	<#comment>无视图模式-查询view的数据查询</#comment>
	<#if item.isNoViewMode()==true>
		<#list dataQueries as singleQuery>
			<#if singleQuery.getCodeName()?lower_case=='view'>
				<#if singleQuery.getAllPSDEDataQueryCodes()??>
					<#assign queryCodeList = singleQuery.getAllPSDEDataQueryCodes()>
					<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
						<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="selectById"  resultMap="${de.codeName}ResultMap" databaseId="${dbtype}">
		<![CDATA[	select t1.* from (
		${srfjavasqlcode('${dedqcode.getQueryCode()}')}
		)t1     where  ${de.getKeyPSDEField().name?lower_case}=<#noparse>#{id}</#noparse>]]>
	</select>
					</#list>
				</#if>
				<#break>
			</#if>
		</#list>
	<#else>
		<#comment>直接查询视图</#comment>
		<#list dataQueries as singleQuery>
			<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
				<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="selectById"  resultMap="${de.codeName}ResultMap" databaseId="${dbtype}">
		<![CDATA[	select t1.* from (
		select * from ${item.getViewName()?lower_case}
		)t1     where  ${de.getKeyPSDEField().name?lower_case}=<#noparse>#{id}</#noparse>]]>
	</select>
			</#list>
		<#break>
		</#list>
	</#if>
	<!--通过mybatis将查询结果注入到entity中,通过配置autoMapping="true"由mybatis自动处理映射关系 -->
	<resultMap id="${de.codeName}ResultMap" type="${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.domain.${item.codeName}" autoMapping="true">
		<id property="${item.getKeyPSDEField().codeName?lower_case}" column="${item.getKeyPSDEField().getName()?lower_case}" /><!--主键字段映射-->
		<#comment>外键值字段映射：由于需要将一个数据库列注入到2个domian属性中(主关系实体对象)，由于已经手动将列映射给主关系对象，所以autoMapping将不会自动注入外键id，需要再次声明映射关系</#comment>
		<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
			<#list item.getMinorPSDERs() as MinorPSDER>
				<#if MinorPSDER??  && MinorPSDER.getDERType()=='DER1N'>
					<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
						<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
						<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
							<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
								<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
								<#assign MajorField = MinorPSDER.getPSPickupDEField()>
		<result property="${MajorField.codeName?lower_case}" column="${MajorField.getName()?lower_case}" /><!--关系字段映射-->
							</#if>
						</#if>
					</#if>
				</#if>
			</#list>
		</#if>
		<#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
		<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
		<#list item.getMinorPSDERs() as MinorPSDER>
		<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
		<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
			<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
			<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
			<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
			<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
			<#assign MajorField = MinorPSDER.getPSPickupDEField()>
		<!--通过mybatis自动注入关系属性[主实体]，fetchType="lazy"为懒加载配置 -->
		<association property="${MinorPSDER.getCodeName()?lower_case}" javaType="${pub.getPKGCodeName()}.${MajorEntity.getPSSystemModule().codeName?lower_case}.domain.${MajorEntity.codeName}" column="${MajorField.getName()?lower_case}" select="${pub.getPKGCodeName()}.${MajorEntity.getPSSystemModule().codeName?lower_case}.mapper.${MajorEntity.codeName}Mapper.selectById" fetchType="lazy"></association>
			</#if>
			</#if>
		</#if>
		</#if>
		</#list>
		</#if>
		<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>
		<#if item.getMajorPSDERs?? && item.getMajorPSDERs()??>
		<#list item.getMajorPSDERs() as MajorPSDER>
		<#if MajorPSDER??>
		<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()?? && MajorPSDER.getMinorCodeName?? && MajorPSDER.getMinorCodeName()?? && MajorPSDER.getDERType()=='DER1N'>
			<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
			<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>
			<#if MinorEntity.name?? && MajorPSDER.getCodeName()?? && MajorPSDER.getMinorCodeName()!=''>
		<!--通过mybatis自动注入关系属性[关系实体]，fetchType="lazy"为懒加载配置 -->
		<collection property="${MajorPSDER.getMinorCodeName()?lower_case}" ofType="${pub.getPKGCodeName()}.${MinorEntity.getPSSystemModule().codeName?lower_case}.domain.${MinorEntity.codeName}" column="${item.getKeyPSDEField().getName()?lower_case}" select="${pub.getPKGCodeName()}.${MinorEntity.getPSSystemModule().codeName?lower_case}.mapper.${MinorEntity.codeName}Mapper.selectBy${MajorDerField.getName()?lower_case}" fetchType="lazy"></collection>
			</#if>
		</#if>
		</#if>
		</#list>
		</#if> 
	</resultMap>
	<#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>
	<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
	<#list item.getMinorPSDERs() as MinorPSDER>
	<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
	<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>
	<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
	<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >
	<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>
	<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>
	<#assign MajorField = MinorPSDER.getPSPickupDEField()>
	<!--关系实体暴露select方法供主实体通过外键查询关系实体数据[实体关系名称:${MinorPSDER.getName()}] -->
			<#if item.getAllPSDEDataQueries()??>
				<#list item.getAllPSDEDataQueries() as singleQuery>
				<#if singleQuery.getCodeName()?lower_case=='default'>
				<#if singleQuery.getAllPSDEDataQueryCodes()??>
					<#assign queryCodeList = singleQuery.getAllPSDEDataQueryCodes()>
						<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
						<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="selectBy${MajorField.getName()?lower_case}"  resultMap="${de.codeName}ResultMap" databaseId="${dbtype}">
			<![CDATA[	select m1.* from(	select t1.* from (
					${srfjavasqlcode('${dedqcode.getQueryCode()}')}
			)t1   ) m1  where  ${MajorField.getName()?lower_case}=<#noparse>#{</#noparse>${MajorkeyField.codeName?lower_case}<#noparse>}</#noparse>
			]]>
	</select>
						</#list>
				</#if>
				<#break>
				</#if>
				</#list>
			</#if>
	</#if>
	</#if>
	</#if>
	</#if>
	</#list>
	</#if>
	<#comment>暂未实现多数据源，暂时先发布单数据库</#comment>
	<#if resultSet??> 
	<#list resultSet as  singleSet>
	<#if singleSet.getPSDEDataQueries()??>
	<#assign resultDataQuery = singleSet.getPSDEDataQueries()>
	<#list resultDataQuery as singleQuery>
	<!--输出平台内配置的数据查询[${singleQuery.getName()}]-->
		<#if singleQuery.getAllPSDEDataQueryCodes()??>
		<#assign queryCodeList = singleQuery.getAllPSDEDataQueryCodes()>
		<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
			<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="search${singleSet.getCodeName()}"  parameterType="${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.service.dto.${item.getCodeName()}SearchFilter"  resultMap="${de.codeName}ResultMap" databaseId="${dbtype}">
		select t1.* from (
        <![CDATA[	${srfjavasqlcode('${dedqcode.getQueryCode()}')}  ]]>
             <if test="srf.permissionCond!=null and srf.permissionCond.sqlSegment!=null"><#noparse>${srf.permissionCond.sqlSegment}</#noparse></if>
				<#if dedqcode.getPSDEDataQueryCodeConds()??>
		  <![CDATA[	<#list dedqcode.getPSDEDataQueryCodeConds() as dedqfieldcond>
					<#if (dedqfieldcond_index==0)> WHERE </#if>	<#if (dedqfieldcond_index>0)> AND 	</#if>
			${srfjavasqlcode('${dedqfieldcond.getCustomCond()}') }
				</#list>
			  ]]>
				</#if>
		)t1
			<where><if test="ew!=null and ew.sqlSegment!=null and !ew.emptyOfWhere"><#noparse>${ew.sqlSegment}</#noparse></if></where>
				   <if test="ew!=null and ew.sqlSegment!=null and ew.emptyOfWhere"><#noparse>${ew.sqlSegment}</#noparse></if>
	</select>
		</#list>
		</#if>
	</#list>
	</#if>
	</#list>
	</#if>
		<#comment>权限查询</#comment>
		<#list item.getAllPSDEDataQueries() as singleQuery>
			<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
				<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="selectPermission"  resultMap="${de.codeName}ResultMap" databaseId="${dbtype}">
			select t1.* from (
        <![CDATA[ ${srfjavasqlcode('${dedqcode.getQueryCode()}')} ]]>
        	<if test="pw!=null and pw.sqlSegment!=null"><#noparse>${pw.sqlSegment}</#noparse></if>
		)t1
	</select>
			</#list>
			<#break>
		</#list>
</mapper>
