<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#if  item.getAllPSDEDataSets()??>
<#assign resultSet=item.getAllPSDEDataSets()>
</#if>
<#if  item.getAllPSDEDataQueries()??>
<#assign dataQueries=item.getAllPSDEDataQueries()>
</#if>
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper
        namespace="${pub.getPKGCodeName()}.ibizutil.mapper.IBZWorkFlowMapper">

    <update id="updateOne"
            parameterType="${pub.getPKGCodeName()}.ibizutil.domain.Worklist">
        update T_WORKLIST t
        <trim prefix="set" suffixOverrides=",">
            <if test="worklist.extensions.createmandirtyflag != null and true == worklist.extensions.createmandirtyflag"> createman = ${r'#{worklist.createman}'}, </if>
            <if test="worklist.extensions.createdatedirtyflag != null and true == worklist.extensions.createdatedirtyflag"> createdate = ${r'#{worklist.createdate}'}, </if>
            <if test="worklist.extensions.worklistnamedirtyflag != null and true == worklist.extensions.worklistnamedirtyflag"> worklistname = ${r'#{worklist.worklistname}'}, </if>
            <if test="worklist.extensions.updatedatedirtyflag != null and true == worklist.extensions.updatedatedirtyflag"> updatedate = ${r'#{worklist.updatedate}'}, </if>
            <if test="worklist.extensions.updatemandirtyflag != null and true == worklist.extensions.updatemandirtyflag"> updateman = ${r'#{worklist.updateman}'}, </if>
            <if test="worklist.extensions.useriddirtyflag != null and true == worklist.extensions.useriddirtyflag"> userid = ${r'#{worklist.userid}'}, </if>
            <if test="worklist.extensions.workflowiddirtyflag != null and true == worklist.extensions.workflowiddirtyflag"> workflowid = ${r'#{worklist.workflowid}'}, </if>
            <if test="worklist.extensions.workflownamedirtyflag != null and true == worklist.extensions.workflownamedirtyflag"> workflowname = ${r'#{worklist.workflowname}'}, </if>
            <if test="worklist.extensions.stepdirtyflag != null and true == worklist.extensions.stepdirtyflag"> step = ${r'#{worklist.step}'}, </if>
            <if test="worklist.extensions.businesskeydirtyflag != null and true == worklist.extensions.businesskeydirtyflag"> businesskey = ${r'#{worklist.businesskey}'}, </if>
            <if test="worklist.extensions.startuseriddirtyflag != null and true == worklist.extensions.startuseriddirtyflag"> startuserid = ${r'#{worklist.startuserid}'}, </if>
            <if test="worklist.extensions.starttimedirtyflag != null and true == worklist.extensions.starttimedirtyflag"> starttime = ${r'#{worklist.starttime}'}, </if>
        </trim>
        where t.worklistid = ${r'#{worklist.worklistid}'}
    </update>

    <!--该方法用于重写mybatis中selectById方法，以实现查询逻辑属性-->
    <select id="selectById"  resultMap="WorklistResultMap" databaseId="mysql">
        <![CDATA[	select t1.* from (
        select * from v_worklist
        )t1     where  worklistid=${r'#{id}'}]]>
    </select>

    <!--通过mybatis将查询结果注入到entity中,通过配置autoMapping="true"由mybatis自动处理映射关系 -->
    <resultMap id="WorklistResultMap" type="${pub.getPKGCodeName()}.ibizutil.domain.Worklist" autoMapping="true">
        <id property="worklistid" column="worklistid" /><!--主键字段映射-->



    </resultMap>


    <!--输出平台内配置的数据查询[My]-->
    <select id="searchMy"  parameterType="${pub.getPKGCodeName()}.ibizutil.domain.WorklistSearchFilter"  resultMap="WorklistResultMap" databaseId="mysql">
        <![CDATA[select t1.* from (
        SELECT t1.`BUSINESSKEY`, t1.`CREATEDATE`, t1.`CREATEMAN`, t1.`STARTTIME`, t1.`STARTUSERID`, t1.`STEP`, t1.`UPDATEDATE`, t1.`UPDATEMAN`, t1.`USERID`, t1.`WORKFLOWID`, t1.`WORKFLOWNAME`, t1.`WORKLISTID`, t1.`WORKLISTNAME` FROM `T_WORKLIST` t1
        )t1]]>
        <where><if test="ew!=null and ew.sqlSegment!=null and !ew.emptyOfWhere">${r'${ew.sqlSegment}'}</if></where>
        <if test="ew!=null and ew.sqlSegment!=null and ew.emptyOfWhere">${r'${ew.sqlSegment}'}</if>
    </select>
    <!--输出平台内配置的数据查询[DEFAULT]-->
    <select id="searchDefault"  parameterType="${pub.getPKGCodeName()}.ibizutil.domain.WorklistSearchFilter"  resultMap="WorklistResultMap" databaseId="mysql">
        <![CDATA[select t1.* from (
        SELECT t1.`BUSINESSKEY`, t1.`CREATEDATE`, t1.`CREATEMAN`, t1.`STARTTIME`, t1.`STARTUSERID`, t1.`STEP`, t1.`UPDATEDATE`, t1.`UPDATEMAN`, t1.`USERID`, t1.`WORKFLOWID`, t1.`WORKFLOWNAME`, t1.`WORKLISTID`, t1.`WORKLISTNAME` FROM `T_WORKLIST` t1
        )t1]]>
        <where><if test="ew!=null and ew.sqlSegment!=null and !ew.emptyOfWhere">${r'${ew.sqlSegment}'}</if></where>
        <if test="ew!=null and ew.sqlSegment!=null and ew.emptyOfWhere">${r'${ew.sqlSegment}'}</if>
    </select>
</mapper>
